﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace Windows_close_test
{
    public class MainViewModel : INotifyPropertyChanged
    {
        #region Create New Window
        private ICommand createNewWindowCommand;
        public ICommand CreateNewWindowCommand
        {
            get { return createNewWindowCommand = new delegateCommand(createNewWindow); }
        }
        public void createNewWindow()
        {
            for (int z = 0; z < 100; z++)
            {

                Window win = new Window();
                Grid grid = new Grid();
                TextBox text = new TextBox();

                text.Text = "Hello World";
                win.Content = grid;
                grid.Children.Add(text);

                win.Closed += (s, e) =>
                {
                    text = null;
                    grid = null;
                    win = null;
                };

                win.Show();
            }

        }
        #endregion

        #region close new Window
        private ICommand closeNewWindowCommand;
        public ICommand CloseNewWindowCommand
        {
            get { return closeNewWindowCommand = new delegateCommand(closeNewWindow); }
        }
        public void closeNewWindow()
        {
           
            while(true)
            {
                if (Application.Current.Windows.Count == 1)
                    return;
                else
                {
                    Application.Current.Windows[1].Close();
                }
            }

        }
        #endregion

        #region get Memory
        private ICommand getMemoryCommand;
        public ICommand GetMemoryCommand
        {
            get { return getMemoryCommand = new delegateCommand(getMemory); }
        }
        public void getMemory()
        {
            Process proc = Process.GetCurrentProcess();
            Console.WriteLine(" memory : {0}  toTal : {1}  windows {2} ", proc.PrivateMemorySize64 / 1024 / 1024,GC.GetTotalMemory(true) ,Application.Current.Windows.Count);

        }
        #endregion

        #region Collect Gc
        private ICommand collectGcCommand;
        public ICommand CollectGcCommand
        {
            get { return collectGcCommand = new delegateCommand(CollectGc); }
        }
        public void CollectGc()
        {
            GC.Collect();
        }
        #endregion

        #region OnPropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion
    }
}
